
;			jp	MainPrg			; Start     
			
	;{ 	InitInterrupt
			
_ItVectorSave:		ds	3,0
			
InitInterrupt:		
;			di
			
;			ld	hl,$38
;			ld	de,_ItVectorSave
;			ldi
;			ldi
;			ldi
			
;			ld	hl,$38
;			ld	(hl),$c3		; JP kdja
;			inc	hl
;			ld	de,MyInterruptEntry
;			ld	(hl),e
;			inc	hl
;			ld	(hl),d
			
;			ld	a,($b12)		; Hang megszakts letiltsa
;			res	5,a
			xor	a
			out	(5),a
			
;			ei
			ret
			
DeinitInterrupt:		
;			di
			
;			ld	hl,_ItVectorSave
;			ld	de,$38
;			ldi
;			ldi
;			ldi
			
;			ld	a,($b12)		; Az eredeti megszaktsi rendszer engedlyezse
;			out	(5),a

			ld	a,81h
			out	(06h),a
			
;			ld	hl,$0b51
;			ld	b,10
;			xor	a
DeinitInterrupt_DeinitInner:		
;			ld	(hl),a
;			inc	hl
;			djnz	DeinitInterrupt_DeinitInner
			
;			ei
			ret
			
	;}				
			
			
	;{	MyInterrupt	
			
MyInterruptEntry:	
;			push	af
;			
;			ld	a,$70
;			out	(2),a
;			
;			push	bc
;			push	de
;			push	hl
;			push	ix
;		;	push	iy
;			ex	af,af'
;			push	af
;			exx
;			push	bc
;			push	de
;			push	hl
;			
;			call	MyInterrupt
;			
;			pop	hl
;			pop	de
;			pop	bc
;			exx
;			pop	af
;			ex	af,af'
;		;	pop	iy
;			pop	ix
;			pop	hl
;			pop	de
;			pop	bc
;			
;			ld	a,(3)
;			out	(2),a
;			
;			pop	af
;			ei
			ret
			
MyInterrupt:		
			ld	a,$ff
			ld	($0b20),a		; Megszakts futsnak jelzse
			
			ld	hl,($0b1d)		; Timer lptetse
			inc	hl
			ld	($0b1d),hl
			
			in	a,($59)			; Az IT forrs lekrdezse (als 5 bit 0 rtkkel jelzi a forrst)
			out	(7),a
			
			; A billentyumtrix beolvassa
			ld	a,($0b11)		; A 3-as port kpija
			and	$f0
			ld	c,a
			
			ld	hl,$0b51		; Ez a billenytu PICTURE mtrix kezdocme
			ld	b,10
MyInterrupt_KbdInner:		
			ld	a,c
			out	(3),a			; Billentyu sor kivlasztsa
			in	a,($58)
			cpl
			ld	(hl),a
			inc	hl
			inc	c
			djnz	MyInterrupt_KbdInner
			
			; Ide jhet brmi ms feladat, amit a mexaktsnak meg kell csinlnia
			call	MusicPlayerIT
			
			ld	a,0
			ld	($b20),a		; Megszakts futsnak jelzsnek trlse
			
			ret
			
	;}
			
			
	;{	MainPrg			
MainPrg:			
			push	iy
			
			call	InitMusicPlayer
			call	StartMusic
			;jr	MainPrg_Vege
			
			call	InitInterrupt
MainPrg_MainInner:		
			in	a,(59h)
			and	10h
			jr	nz,MainPrg_MainInner
			out	(07h),a

			call	MusicPlayerIT
			call	bigchar.key
			jr	z,MainPrg_MainInner

			
			call	DeinitInterrupt
			
			ld	a,(MaskPort6)		; Hang letilts
			out	(6),a
MainPrg_Vege:			
			pop	iy
			ret
	;}
			
			
;			#define	LOOP_MIXER 1
			
			
			
EMPTY_SOUND:		EQU	72
			
MUSIC_TEMPO:		EQU	9
MUSIC_MIXER:		EQU	1
			
; A kvetkezo vltozk sorrendje nem mdosthat!!!			
AddrFreqTable:		dw	0			; A FreqTable cme
AddrEnvelopes:		dw	0			; Az Envelopes tblzat cme
AddrTrack0:		dw	0			; A 0-s track lista cme
AddrTrack1:		dw	0			; Az 1-es track lista cme
AddrPatternOffs:		dw	0			; A PatternOffs tblzat cme
AddrPatterns:		dw	0			; A Pattern-ek kezdetnek a cme
EnvelopesNr:		db	0			; Ennyi "hangszer" (burkol grbe) van a zenben
MaskPort5:		db	0
MaskPort6:		db	0
MP_Flag:			db	0			; A 7. bit jelzi melyik csatorna szl a mixerben, 0. bitje engedlyezi a zene lptetst
MP_TempoCounter:		db	0			; Temp szmll
MP_MixerCounter:		db	MUSIC_MIXER		; Mixer szmll
			
	;{	InitMusicPlayer	
	;	A MusicData cmtol kezdodoen tallhat a zene teljes adathalmaza, ami mindjrt a 6 klnbzo rsz eltolsi rtkeit tartalmazza a MusicData-hoz kpest
InitMusicPlayer:		
			; elso krben a zene alap adataibl elolltjuk az egyes rszek cmeit
			xor	a
			ld	(MP_Flag),a
			
			ld	hl,MusicData		; 'HL'-lel a zene adatok elejre llunk 	(forrs pointer)
			ld	de,AddrFreqTable	; 'DE'-vel meg az alap vltoztmb elso elemre (cl pointer)
			ld	b,6
InitMusicPlayer_Inner1:			
			push	bc			; Elmentjk a ciklus szmllt
			
			ld	c,(hl)			; 'BC'-be kerl az aktulis zene adat rsz eltolsi rtke
			inc	hl
			ld	b,(hl)
			inc	hl
			
			push	hl			; Mivel 'HL' a kvetkezo alap adatra mutat ezrt elmentjk
			
			ld	hl,MusicData		; 'HL' = MusicData + 'BC' (MusicData + eltols)
			add	hl,bc
			
			ld	c,l			; 'BC' = 'HL'
			ld	b,h
			
			ex	de,hl			; Ez a rsz lnyegben a kvetkezo - nem ltezo - utastsnak felel meg: LD (DE),BC
			ld	(hl),c
			inc	hl
			ld	(hl),b
			inc	hl
			ex	de,hl
			
			pop	hl			; Visszatltjk a 'HL'-be a forrs pointer rtkt
			pop	bc			; 'B'-be meg a ciklusvltozt
			djnz	InitMusicPlayer_Inner1
			
			; Ezutn letroljuk a kt csatorna track tmbjeinek a hosszt ill. a vgcmt				
			ld	a,(hl)
			dec	a
			ld	(Ch0_TrackSize),a
			inc	hl
			
			ld	a,(hl)
			dec	a
			ld	(Ch1_TrackSize),a
			
			inc	hl
			ld	d,(hl)			; 'D' = EnvelopeNr
			inc	hl
			ld	e,(hl)			; 'E' = Envelope shift
			
			ld	hl,(AddrTrack0)
			ld	(Ch0_TrackAddr),hl
			ld	hl,(AddrTrack1)
			ld	(Ch1_TrackAddr),hl
			
			ld	a,d
			ld	(EnvelopeNr),a
			
			; A GetNenvelopeAddr rutinban belltjuk a szorz rtkhez tartoz eltolst. Lsd: GetEnvelopeAddr rutin!!!
			ld	hl,GetEnvAddrMod
InitMusicPlayer_Inner:			dec	hl
			dec	e
			jr	nz,InitMusicPlayer_Inner
			ld	(GetEnvelopeAddr+2),hl	
			
			; A Port6 maszkjt is elolltjuk, ezzel az rtkkel kel majd OR-olni a hangerot a kirs elott
;			ld	a,($b13)		; Port6 tkr
			ld	a,$81
			and	$c3
			ld	(MaskPort6),a
			
			; Ugyan gy elolltjuk a hangmagassg felso 4 bitjnek a maszkjt is. Ezzel az rtkkel kell majd OR-olni a hangmagassg rtk felso 4 bitjt
;			ld	a,($b12)		; Port5 tkr
			xor	a
			and	$c0
			or	16
			ld	(MaskPort5),a
			
			ret
	;}
			
			; A zene alap elemei a patternek. Ezek mutatjk meg milyen (zenei) hang kerl letsre, melyik "hangszer" szl s, hogy ez a hang meddig rvnyes.
			; A pattern hossza vltoz lehet. Legtbbszr a hossz 8, 16, 32 vagy 64 pozci 
			; A patternen bell a zenei hang egy index, mgpedig a FreqTable adott elemnek indexe
			; A "hangszer" - nagyon nagyzolsan hangszer!! :) - nem ms, mint egy burkol grbe tblzat indexe A tblzat minden byte-ja egy-egy hangero rtket jell, s ezeket az rtkeket
			; a mixer ciklikusan lptetve kldi ki majd a 6-os portra 
			
			; A pattern felptse:
			; Az elso byte a pattern teljes hossza
			; Ez utn kvetkeznek a letsek, mely szerkezete:
			;	FreqTableIndex: 	a ferkvencia tbla adott elemt jelli
			;	Hangszer:		Megmutatja, hogy az 'Envelopes' tblbl melyik tbla az aktulis
			;	Delay:			Ez egy szmll. Megmutatja, hogy a kvetkezo hangszerig hny pattern pozcit kell lpni
			
			; A zene msik eleme az un. Track lista. Mindkt csatornhoz kln track lista tartozik. Ezek byte-jai mutatjk, hogy mely pattern-t kell sorrendben lejtszani.
			; gy nagyon hatkony mdon tudjuk trolni az ismtlseket. (Pl: 1,1,1,1,2,2 track lista azt jelenti, hogy eloszr lejtszuk ngyszer az 1-es majd utna ktszer a 2-es patternt)
			
			; Mivek a struktra egyes elemei az 'IX' regiszter segtsgvel lesznek kezelve, ezrt a kvetkezo felsorols az egyes elemek cmzst segti elo
			; enum	CH_TrackSize, CH_TrackPtr, CH_TrackAddrL, CH_TrackAddrH, CH_PatternPtrL, CH_PatternPtrH, CH_PatternSize, CH_PatternSizeCnt, CH_PatternDelay, CH_PitchL, CH_PitchH, CH_Volume,
			;	CH_EnvelopePtrL, CH_EnvelopePtrH
			
; Csatorna strukturk. Figyelem, a sorrendjt nem clszeru megvltoztatni vagy ha mgis, akkor az elozo felsorolst is megfeleloen mdostani kell!!!				
CHANNEL_STRUCT_SIZE:	EQU	14

Ch_TrackSize		=	0			; A Track ler mrete. Ehhez a csatornhoz sszesen ennyi track tartozik (ennyi byte-bl ll).
Ch_TrackPtr		=	1			; Track mutat: megmutatja, hogy ppen melyik pattern van lejtszs alatt. rteke 0 s TrackSize-1 kztt vltozik  
Ch_TrackAddr		=	2			; Mutatja az adott csatorna track listjnak az elso elemnek a cmt
Ch_TrackAddrL		=	2			; Mutatja az adott csatorna track listjnak az elso elemnek a cmt
Ch_TrackAddrH		=	3			; Mutatja az adott csatorna track listjnak az elso elemnek a cmt
Ch_PatternPtr		=	4			; A pattern adott pozcijnak a cme.
Ch_PatternPtrL		=	4			; A pattern adott pozcijnak a cme.
Ch_PatternPtrH		=	5			; A pattern adott pozcijnak a cme.
Ch_PatternSize		=	6			; Ez a vltoz tartalmazza a pattern mrett (Tipikusan 8, 16, 32 v. 64)
Ch_PatternSizeCnt	=	7			; Ebben a vltozban sszegezzk majd a PatternDelay elemek rtkt. Mikor ez az rtk elrte a PatternSize rtkt, akkor vge a patternnek
Ch_PatternDelay		=	8			; Ez lnyegben egy visszafel szmll. Minden j letskor feltltodik. A pattern pozci lptetsekor cskken az rtke 1-el. Mikor 0-ra r, akkor kell feldolgozni a kvetkezo letst
Ch_Pitch		=	9			; Az adott csatorna hangmagassga..
Ch_PitchL		=	9			; Az adott csatorna hangmagassga..
Ch_PitchH		=	10			; Az adott csatorna hangmagassga..
Ch_Volume		=	11			; s hangereje 
Ch_EnvelopePtr		=	12			; A burkol grbe adott elemre mutat. Figyelem!! A Pitch, a Volume s az EnvelopePtr sorrendje nem megcserlheto!!
Ch_EnvelopePtrL		=	12			; A burkol grbe adott elemre mutat. Figyelem!! A Pitch, a Volume s az EnvelopePtr sorrendje nem megcserlheto!!
Ch_EnvelopePtrH		=	13			; A burkol grbe adott elemre mutat. Figyelem!! A Pitch, a Volume s az EnvelopePtr sorrendje nem megcserlheto!!


Ch0_Structure:	
Ch0_TrackSize:		db	0			; A Track ler mrete. Ehhez a csatornhoz sszesen ennyi track tartozik (ennyi byte-bl ll).
Ch0_TrackPtr:		db	0			; Track mutat: megmutatja, hogy ppen melyik pattern van lejtszs alatt. rteke 0 s TrackSize-1 kztt vltozik  
Ch0_TrackAddr:		dw	0			; Mutatja az adott csatorna track listjnak az elso elemnek a cmt
Ch0_PatternPtr:		dw	0			; A pattern adott pozcijnak a cme.
Ch0_PatternSize:	db	0			; Ez a vltoz tartalmazza a pattern mrett (Tipikusan 8, 16, 32 v. 64)
Ch0_PatternSizeCnt:	db	0			; Ebben a vltozban sszegezzk majd a PatternDelay elemek rtkt. Mikor ez az rtk elrte a PatternSize rtkt, akkor vge a patternnek
Ch0_PatternDelay:	db	0			; Ez lnyegben egy visszafel szmll. Minden j letskor feltltodik. A pattern pozci lptetsekor cskken az rtke 1-el. Mikor 0-ra r, akkor kell feldolgozni a kvetkezo letst
Ch0_Pitch:		dw	0			; Az adott csatorna hangmagassga..
Ch0_Volume:		db	0			; s hangereje 
Ch0_EnvelopePtr:	dw	0			; A burkol grbe adott elemre mutat. Figyelem!! A Pitch, a Volume s az EnvelopePtr sorrendje nem megcserlheto!!
			
Ch1_Structure:	
Ch1_TrackSize:		db	0
Ch1_TrackPtr:		db	0
Ch1_TrackAddr:		dw	0
Ch1_PatternPtr:		dw	0
Ch1_PatternSize:	db	0
Ch1_PatternSizeCnt:	db	0
Ch1_PatternDelay:	db	0
Ch1_Pitch:		dw	0
Ch1_Volume:		db	0			
Ch1_EnvelopePtr:	dw	0
			
	;{	StartMusic
	;	Elindtja a zent				
StartMusic:		
			; Elso lpsben nullzza a TempoCounter-t s a kt csatorna TrackPtrjt
			xor	a
			ld	(MP_TempoCounter),a
			ld	(Ch0_TrackPtr),a
			ld	(Ch1_TrackPtr),a
			
			; Majd feltltjk a 2 csatorna Pattern cmeit a legelso track adataical
			ld	ix,Ch0_TrackSize
			call	SetPatternOfTrack
			
			ld	ix,Ch1_TrackSize
			call	SetPatternOfTrack
			
			; s nullzzuk az EnvelopePtr rtkt azaz nincs rvnyes hangszer!!!
			ld	hl,0
			ld	(Ch0_EnvelopePtr),hl
			ld	(Ch1_EnvelopePtr),hl
			
			ld	a,1			; MP_Flag 0. bitje bell: mehet a zene lptetse
			ld	(MP_Flag),a
			
			ret
	;}
			
	;{	SetPatternOfTrack	
	;	Hvskor 'IX' a csatorna struktra adott elemnek kezdocmt tartalmazza. Track vltskor hvdik meg
SetPatternOfTrack:	
			ld	l,(ix+CH_TrackAddrL)	; 'HL' = TrackAddr
			ld	h,(ix+CH_TrackAddrH)
			ld	c,(ix+CH_TrackPtr)
			
			ld	b,0
			add	hl,bc			; 'HL' mostmr a konkrt Track cmt tartalmazza, amire a TrackPtr mutat
			
			ld	a,(hl)			; 'A'-ba betltjk az adott csatorna patternjt
			add	a,a			; Mivel az PatternOffset tbla 2 byte-os, ezrt 'A'-r szorozzuk 2-vel
			
			ld	hl,(AddrPatternOffs)	; 'HL' a PatternOffset tbla kezdocme
			ld	c,a			; 'BC' = 'A'
			ld	b,0
			add	hl,bc			; 'HL' a pattern eltolsi cme a PatternOffset tblban
			
			ld	c,(hl)			; 'BC'-be betltjk a tblzatbl az elso patternhez kpesti eltolsi cmet
			inc	hl
			ld	b,(hl)
			
			ld	hl,(AddrPatterns)	; Ehhez mh hozz kell adni az elso pattern elejt
			add	hl,bc			; 'HL' a pattern adatok elejre mutat!!!
			
			ld	a,(hl)			; 'A' az adott pattern teljes hossza
			inc	hl
			
			ld	(ix+CH_PatternPtrL),l	; Letroljuk a pattern cmt
			ld	(ix+CH_PatternPtrH),h
			ld	(ix+CH_PatternSize),a	; s a hosszt
			xor	a
			ld	(ix+CH_PatternSizeCnt),a; majd nullzzuk a PatternSizeCnt-t s a PatternDelayt
			ld	(ix+CH_PatternDelay),a
			ret
	;}
			
	;{	MusicPlayerIT				
MusicPlayerIT:		
			ld	a,(MP_Flag)		; Az MP_Flag 0. bitje engedlyezi a zene lptetst
			bit	0,a			; ha a 0. bit nincs belltva..
			ret	z			; .. akkor egyszeruen csak kilpnk
			
			ld	a,(MP_TempoCounter)	; 'A'-ba tltjk a tempo szmllt
			or	a
			jr	z,MusicPlayerIT_StepPattern0		; Ha a tempo szmll (MP_TempoCounter) akkor kell lptetni tovbb a zent
			inc	a			; Ha a tempo szmll nem 0 volt, akkor noveljk eggye az rtkt
			cp	MUSIC_TEMPO		; Megvizsgljuk, hogy a nvelt rtk elrte-e a zene tem rtkt
			jr	nz,MusicPlayerIT_StoreTempoCounter	; Ha nem, egyszeruen csak letroljuk az j rtket
			xor	a			; Ha elrte a zene tempo rtkt, akkor a tempo szmllt nullzzuk
MusicPlayerIT_StoreTempoCounter:	
			ld	(MP_TempoCounter),a	; Majd letroljuk az j rtket..
			jp	MusicPlayerIT_Mixer			; .. s lnk a Mixerre
			
MusicPlayerIT_StepPattern0:		
			; Lptetni kell a zent..
			inc	a			; 'A' a tempo szmltl, hozz kell adni egyet a tovbbiakhoz
			ld	(MP_TempoCounter),a	; s le is kell trolni az rtkt
			
			ld	ix,Ch0_Structure	; 'IX' a 0-s track struktrjra mutat
			call	StepPattern		; s meghvjuk a csatorna lptetst

			ld	ix,Ch1_Structure	; 'IX' most az 1-es track struktrjra mutat
			call	StepPattern		; s lptetjk a csatit
			
			; A mixer feladata kettos:
			; Egyrszt ez gondoskodik felvltva a kt hangcsatorna hang adatainak (Hangmagassg, Hangero) kikldsre a portokra
			; Msrszt mindkt csatornn lpteti a burkol grbe mutatt (EnvelopePointer-t). 
			; Ez hatrozza meg, hogy az adott pillanatban az adott csatornn mi az rvnyes hangero. (Az Envelopes tblzat megfelelo elemre mutat)
			
			; (Feltteles fordtssal lehet loop-olt vagy nem loop-olt mixert fordtani. Csak a loop-olt, teht a bonyolultabb mixer rutin lesz magyarzva albb)

MusicPlayerIT_Mixer:			
;			#ifdef	LOOP_MIXER
			
			; Ide jn a kt csatorna envelope lptetse. Ezt praktikusan egy ciklusba foglaltuk				
			ld	b,2
			ld	hl,Ch0_EnvelopePtr	; 'HL' az elso csatorna struktra 'EnvelopePointer" cmre mutat
MusicPlayerIT_EnvInner:		
			
			push	hl
			
			ld	e,(hl)			; 'DE'-be betltjk az EnvelopePointer rtkt
			inc	hl
			ld	d,(hl)
			
			ld	a,d			; ha 'DE' = 0, akkor nincs envelope lptets
			or	e
			jr	z,MusicPlayerIT_Ok
			
			dec	hl			; 'HL' = 'HL' - 2, gy 'HL' most a csatorna 'Volume' vltozjra mutat
			dec	hl
			
			ld	a,(de)			; Betltjk 'A'-ba az Envelopes tblbl az adott hangerot
			ld	c,a			; s letroljuk ksobbre 'C'-ben
			and	15			; Vesszk az als 4 bitet
			jr	nz,MusicPlayerIT_NotEnvEnd		; Ha eu az rtk nem 0, akkor mg nem rtnk a burkol grbe hangeros sornak a vgre
			
			; hangero sor vge: 'A' = 0, 'HL' most az adott csatorna Volume vltozjt mutatja
			ld	(hl),a			; Nullzzuk a Volume rtkt
			inc	hl
			ld	(hl),a			; Majd nullzzuk az EnvelopePtr rtkt is, gy jelezzk, hogy a burkolgrbe teljesen le van jtszva
			inc	hl
			ld	(hl),a
			jr	MusicPlayerIT_Ok
MusicPlayerIT_NotEnvEnd:		
			ld	(hl),a			; Nem rtnk a burkolgrbe sor vgre, le kell trolni 'A'-t a Volume ('HL' mutatja) vltozba
			inc	hl			; 'HL'-t nveljk, gy 'HL' mr az EnvelopePtr cmt tartalmazza
			
			ld	a,c			; 'A'-ba visszatltjk 'C'-bol az eredeti Envelope rtket
			
			srl	a			; Vesszk 'A'-nak a felso 4 rtkt, s ttoljuk ezeket az als 4 bitbe
			srl	a
			srl	a
			srl	a
			or	a			; Ha a felso 4 bit 0, akkor nincs loop
			jr	nz,MusicPlayerIT_Loop
			
			; Nincs loop... Nveljk az EnvelopePtr-t, majd letroljuk az rtkt (A cmt 'HL' jelli!)
			inc	de
			jr	MusicPlayerIT_StoreEnvPtr		; .. majd letroljuk az EnvelopePtr rtkt
MusicPlayerIT_Loop:			
			; A loop-ot mindig az Envelope tblzat utols hangero adatnak a felso 4 bitje jelli. Ez a felso 4 bit megadja, hogy mennyivel kell vissza ugranunk az EnvelopePtr-rel
			; 'A' als 4 bitje regiszter itt mr azt jelli mennyivel kell visszaugranunk, 'DE' pedig az EnvelopePtr. A kvetkezo rsz egy kis buvszkeds:
			; A kvetkezo muveletet valstja meg: 'DE' = 'DE' - 'A'
			push	bc
			ld	c,a
			ld	b,0
			ex	de,hl
			or	a
			sbc	hl,bc
			ex	de,hl
			pop	bc
MusicPlayerIT_StoreEnvPtr:		
			ld	(hl),e			; Az EnvelopePtr ('DE') letrolsa a 'HL' ltal mutatott cmre.
			inc	hl
			ld	(hl),d
MusicPlayerIT_Ok:			
			pop	hl
			
			; Vgezetl 'HL'-t nveljk a csatorna struktra mretvel, gy lpnk a kvetkezo csatornra
			ld	de,CHANNEL_STRUCT_SIZE
			add	hl,de
			djnz	MusicPlayerIT_EnvInner
MusicPlayerIT_SkipEnvelopeStep:	
			
			; A mixer elozo rsze a kt csatorna struktrjban lltotta be az aktulisan rvnyes hangerot
			; A mixer kvetkezo rsznek ehhez kpest egyszeru a mukdse. Felvltva kikldi a kt csatorna struktrjbl Pitch s Volume rtkt a portokra
			
			ld	a,(MP_MixerCounter)	; Mixer szmllt cskkentjk
			dec	a
			jr	z,MusicPlayerIT_ChangeMixer
			ld	(MP_MixerCounter),a	; Ha mg nem rte el a 0-t, akkor letroljuk az j rtket, nem vltuk a kikldeno csatornk kzt s kilpnk
			ret
MusicPlayerIT_ChangeMixer:		
			ld	a,MUSIC_MIXER		; Elrte a 0-t, jra be kell lljtani a ksleltetst a kvetkezo vltshoz
			ld	(MP_MixerCounter),a	; Le is troljuk az j rtket
			
			ld	a,(MP_Flag)		; 'A'-ba betltjk az MP_Flag rtkt
			bit	7,a
			jr	nz,MusicPlayerIT_SetMixCh0		; a 7-es bit mondja meg, hogy a 0-s vagy az 1-es csatorna hang paramtereit kell a portokra kldeni
			ld	hl,Ch0_Pitch		; enne fggvnyben 'HL'-lel rllunk a 0-s csatorna ..
			jr	MusicPlayerIT_OutSoundParams
MusicPlayerIT_SetMixCh0:		
			ld	hl,Ch1_Pitch		; .. vagy az 1-es csatorna Pitch vltozjra
MusicPlayerIT_OutSoundParams:		
			xor	128			; majd ellenttesre lltjuk az MP_Flag 7-es bitjt
			ld	(MP_Flag),a
MusicPlayerIT_OutSoundParams2:	
			ld	a,(hl)			; 'A'-ba tltjk a pitch rtk als felt, s ki is kldjk a 4-es portra
			inc	hl
			out	(4),a
			
			ld	b,(hl)			; 'B'-be tltjk a pitch rtk felso 4 bitjt
			inc	hl
			
			ld	a,(MaskPort5)		; 'A'-ba pedig az 5-s port maszkjt
			or	b			; 'A'-t s 'B't OR-oljuk, gy nem fog megvltozni a portra kldsnl a port felso 4 bitje
			out	(5),a
			
			ld	a,(hl)			; 'A'-ba most a volume rtkt tltjk ..
			and	15			; .. s vesszk az als 4 bitjt ..
			add	a,a			; .. majd szorozzuk 4-gyel (feltoljuk 2 bittel)
			add	a,a
			ld	b,a			; 'B' most mr a bit helyes hangero rtk
			ld	a,(MaskPort6)		; 'A'-ba jn a 6-os port maszkja
			or	b			; OR-oljuk a hangero ill a maszk rtkt
			out	(6),a			; majd kikldjk a portra
			ret
	;}
			
			
	;{	StepPattern			
	; Ez a rsz hivatott a zene sorait lptetni. Belpskor 'IX' az adott csatorna struktrjra mutat
StepPattern:		
			ld	a,(ix+CH_PatternDelay)	; 'A'-ba tesszk a PatternDelay rtkt
			or	a
			jr	z,StepPattern_NewSound		; Ha 'A'=0, akkor lptetni kell a pattern pozcit
			dec	(ix+CH_PatternDelay)	; Ha nem 0, akkor cskkentjk a PatternDelay-t s nincs tbb dolgunk
			ret
StepPattern_NewSound:		
			ld	a,(ix+CH_PatternSize)
			cp	(ix+CH_PatternSizeCnt)
			jr	nz,StepPattern_LoadSound		; Nincs vge -> Betltjk az j hang adatokat s lptetjk a PatternPtr-t
			
			;Track lptetse	
			ld	a,(ix+CH_TrackPtr)	; 'L'=TrackSize, 'H'=TrackPtr
			cp	(ix+CH_TrackSize)	; Megnzzk, hogy elrtk-e a track lista vgt
			jr	nz,StepPattern_NotEndCh		; Mg nem rtk el, ugrunk a lptetsre
			
			xor	a			; Elrtk a vgt (jra kezdodik a zene!!)
			jr	StepPattern_StoreTracpPtr
StepPattern_NotEndCh:		
			inc	a			; Nveljk a TrackPtr-t, vesszk a kvetkezon lejtszand patternt
StepPattern_StoreTracpPtr:		
			ld	(ix+CH_TrackPtr),a	; Letroljuk az j TrackPtr rtket
			call	SetPatternOfTrack	; Majd belltjuk az jonnan lejtszand pattern alap adatait
StepPattern_LoadSound:		
			; j hang megszlaltatsa
			ld	l,(ix+CH_PatternPtrL)	; 'HL'-be tesszk a lejtszand pattern adatot
			ld	h,(ix+CH_PatternPtrH)
			
			ld	b,(hl)			; 'B' a megszlaltatand hang soundId-je
			inc	hl
			ld	c,(hl)			; 'C' az envelope index
			inc	hl
			ld	a,(hl)			; 'A' a PatternDelay
			inc	hl
			ld	(ix+CH_PatternPtrL),l	; s le is troljuk a PatternPtr-be a kvetkezo pattern sor cmt
			ld	(ix+CH_PatternPtrH),h
			ld	d,a			; 'D' = Pattern delay
			dec	a			; 'A' = PatternDelay - 1
			ld	(ix+CH_PatternDelay),a
			
			ld	a,(ix+CH_PatternSizeCnt); 'A'-ba most a PaternSizeCnt kerl. Ehhez hozz adjuk a PatternDelay rtktt (lnyegben a PatternSizeCnt szmolja, hogy sszesen hnyat lptnk eddig a patternben)
			add	a,d
			ld	(ix+CH_PatternSizeCnt),a
			
			ld	a,b			; 'A' = soundId
			add	a,a			; 'A' = soundId * 2 (mert a FreqTable 2 byte-os elemekbol ll)
			
			ld	e,a
			ld	d,0
			ld	hl,(AddrFreqTable)
			add	hl,de			; 'HL' a FreqTable aktulis elemre mutat
			
			ld	d,(hl)			; 'DE'-be betltjk a FreqTable-bl a PITCH rtket
			inc	hl
			ld	(ix+CH_PitchL),d	; Majd ezt le is troljuk a struktrba
			ld	d,(hl)
			ld	(ix+CH_PitchH),d
			
			; Ide kerlne az envelope inicializlsa. Itt 'C' mutatja az EnvelopeID-t
			
			ld	hl,0			; 'HL'-be 0-t tesznk a ksobbiekre
			cp	EMPTY_SOUND*2		; Ha a soundID (hang index ) =  EMPTY_SOUND * 2  -> Azrt kell az EMPTY_SOUND * 2-vel hasonltani, mert elozoleg 'A' szorozva volt mr 2-vel
			ld	a,0			; 'A'-ba is 0-t tesznk a ksobbiekre (XOR A nem hasznlhat, mert lltan a Z flag-et!!!)
			ld	(ix+CH_Volume),a	; Ideiglenesen a Volume rtkt is nullzzuk
			jr	z,StepPattern_Mute			; s vgl itt dolgozzuk fel az elozo sszehasonlts eredmnyt: ha soundId = EMPTY_SOUND * 2, akkor lekapcsoljuk a hangot ('HL' ugye mr 0!)
			
			call	GetEnvelopeAddr		; Ha nincs lehalkts, akkor viszont 'HL'-be tltjk az aktulis Envelope elem cmt
StepPattern_Mute:			
			ld	(ix+CH_EnvelopePtrL),l	; s le is troljuk
			ld	(ix+CH_EnvelopePtrH),h
			
			ret
	;}
			
	;{	GetEnvelopeAddr				
	; 	Belpskor a 'C' regiszter mondja meg, melyik Envelope elemet kell kivlasztanunk, melyik "hangszer" szl
	; 	Visszatrskor 'HL'-be az adott Envelope elem kezdocme kerl
			
	; 	Az Envelopes tbla minden eleme 2,4,8,16 vagy 32 hossz - azaz minden "hangszer" ugyan annyi byte-on (max 32 byte-on) van letrolva fggetlenl a hosszuktl.
	; 	Gyakorlatilag a leghosszabb hangszer hatrozza meg hny byte-on van letrolva egy-egy "hangszer"
GetEnvelopeAddr:		
			ld	a,c
			jp	GetEnvAddrMod		; Ezt a cmet az InitMusicPlayer lljtja be. Lnyegben ez az ugrs fggvnyben lesz a kvetkezo ADD A,A utastsbl a megfelelo darabszm vgrehajtva
			
			add	a,a			; lnyegben 'A'='A'*2 vagy 'A'='A'*4 vagy 'A'='A'*8 vagy 'A'='A'*16 vagy 'A'='A'*32
			add	a,a
			add	a,a
			add	a,a
			add	a,a
GetEnvAddrMod:		
			ld	c,a			; 'BC' = 'A'
			ld	b,0
			ld	hl,(AddrEnvelopes)	; 'HL'-be berakjuk az Envelopes tbla kezdocmt (InitMusicPlayer lltja be)
			add	hl,bc			; 'HL' = 'HL' + 'BC' ('HL = 'HL' + 'A')
			
			ret
	;}
			
			
MusicData:						; EZ A CMKE MG KELL!! A zene adatait ez al kell msolni!
			
OffsetFreqTable:	dw	16
OffsetEnvelopes:	dw	162
OffsetTrack0:		dw	242
OffsetTrack1:		dw	272
OffsetPatternOffs:	dw	293
OffsetPatterns:		dw	329
SizeTrack0:		db	30
SizeTrack1:		db	21
EnvelopeNr:		db	5
EnvelopeShift:		db	4

FreqTable:
			dw	1110,1277,1436,1585,1726,1859,1984,2103,2215,2320,2420,2514
			dw	2603,2687,2766,2840,2911,2977,3040,3099,3155,3208,3258,3305
			dw	3349,3391,3431,3468,3503,3537,3568,3598,3626,3652,3677,3701
			dw	3723,3744,3763,3782,3800,3816,3832,3847,3861,3874,3887,3898
			dw	3909,3920,3930,3939,3948,3956,3964,3971,3978,3985,3991,3997
			dw	4003,4008,4013,4018,4022,4026,4030,4034,4037,4041,4044,4047
			dw	4095

Envelopes:
			db	15,11,8,7,6,5,4,3,3,0,0,0,0,0,0,0,15,12,10,9,8,7,6,5,4,3,2,49,0,0,0,0
			db	8,4,8,4,2,1,0,0,0,0,0,0,0,0,0,0,4,3,2,49,0,0,0,0,0,0,0,0,0,0,0,0
			db	15,8,6,4,3,2,1,0,0,0,0,0,0,0,0,0

Tracks0:
			db	0,0,1,1,0,0,2,1,0,0,0,0,1,1,0,0,2,1,0,0,0,0,1,1,0,0,2,1,0,0
Tracks1:
			db	3,3,4,4,5,5,6,17,5,7,8,8,8,9,10,11,12,13,14,15,16

PatternOffsets:
			dw	0,25,50,75,100,125,150,175,179,201,223,245,267,289,311,333,355,596
Patterns:
			db	8
			db	11,1,1,11,1,1,13,1,1,11,1,1,14,1,1,11,1,1,16,1,1,14,1,1

			db	8
			db	16,1,1,16,1,1,18,1,1,16,1,1,19,1,1,16,1,1,21,1,1,19,1,1

			db	8
			db	18,1,1,18,1,1,20,1,1,18,1,1,21,1,1,18,1,1,23,1,1,21,1,1

			db	8
			db	35,0,1,35,0,1,37,0,1,35,0,1,38,0,1,35,0,1,40,0,1,38,0,1

			db	8
			db	40,0,1,40,0,1,42,0,1,40,0,1,43,0,1,40,0,1,45,0,1,43,0,1

			db	8
			db	42,0,1,42,0,1,44,0,1,42,0,1,45,0,1,42,0,1,47,0,1,45,0,1

			db	8
			db	49,0,1,49,0,1,51,0,1,49,0,1,52,0,1,49,0,1,54,0,1,52,0,1

			db	5
			db	72,0,5
			db	8
			db	42,0,1,44,0,1,47,0,1,50,0,1,47,0,1,49,0,1,47,0,2
			db	8
			db	47,0,1,49,0,1,52,0,1,50,0,1,47,0,1,49,0,1,47,0,2
			db	8
			db	47,0,1,49,0,1,52,0,1,50,0,1,52,0,1,54,0,1,47,0,2
			db	8
			db	42,0,1,44,0,1,47,0,1,50,0,1,52,0,1,54,0,1,47,0,2
			db	8
			db	42,0,1,44,0,1,47,0,1,57,0,1,54,0,1,56,0,1,54,0,2
			db	8
			db	54,0,1,56,0,1,54,0,1,56,0,1,54,0,1,52,0,1,50,0,2
			db	8
			db	54,0,1,52,0,1,50,0,1,50,0,1,52,0,1,54,0,1,47,0,2
			db	11
			db	42,0,1,44,0,1,47,0,1,50,0,1,47,0,1,49,0,1,47,0,5
			db	80
			db	47,0,1,50,0,1,52,0,1,54,0,1,57,0,1,54,0,1,52,0,1,50,0,1
			db	47,0,1,42,0,1,40,0,1,38,0,1,42,0,1,38,0,1,43,0,1,42,0,1
			db	43,0,1,35,0,1,39,0,1,35,0,1,40,0,1,43,0,1,42,0,1,40,0,1
			db	43,0,1,35,0,1,47,0,1,43,0,1,52,0,1,47,0,1,45,0,1,43,0,1
			db	42,0,1,38,0,1,40,0,1,42,0,1,45,0,1,45,0,1,44,0,1,42,0,1
			db	47,0,1,42,0,1,44,0,1,47,0,1,50,0,1,50,0,1,49,0,1,47,0,1
			db	42,0,1,45,0,1,47,0,1,49,0,1,52,0,1,49,0,1,47,0,1,45,0,1
			db	40,0,1,35,0,1,33,0,1,31,0,1,35,0,1,31,0,1,37,0,1,35,0,1
			db	35,0,1,38,0,1,40,0,1,42,0,1,45,0,1,42,0,1,40,0,1,38,0,1
			db	35,0,1,30,0,1,28,0,1,26,0,1,30,0,1,26,0,1,31,0,1,30,0,1

			db	8
			db	47,0,1,47,0,1,49,0,1,47,0,1,50,0,1,47,0,1,52,0,1,50,0,1

